# -*- encoding : utf-8 -*-
class Portlet::GardeContentsController < ApplicationController
	layout "admin"

	def new
		@garde_content = GardeContent.new
		


		respond_to do |format|
			format.html {
				if request.xhr?
					render :layout => false
				end
			}
			format.js { render :template => "portlet/shared/new" }
		end
	end

	def create
		@garde_content = GardeContent.new(params[:garde_content])

		respond_to do |format|
			if @garde_content.save
				
				
				@portlet = Portlet.create(:position => params[:position], :block_id => params[:block_id], :content => @garde_content)
				
			
				
				
				
				format.html { redirect_to([:admin, @portlet.block.blockable], :notice => 'Elément ajouté avec succès.') }
				format.js { render :template => "portlet/shared/create" }
			else
				format.html { render :action => "new" }
				format.js { render :template => "portlet/shared/new" }
			end
		end
	end

	def edit
		@garde_content = GardeContent.find(params[:id])
		@portlet = Portlet.find(params[:portlet_id])
		
		respond_to do |format|
			format.html {
				if request.xhr?
					render :template => "portlet/shared/edit", :layout => false
				end
			}
			format.js { render :template => "portlet/shared/edit" }
		end
	end
	
	



	def show


	end

	def update
		@garde_content = GardeContent.find(params[:id])
		@portlet = Portlet.find(params[:portlet_id])
		
		respond_to do |format|
	        if @garde_content.update_attributes(params[:garde_content])
				if @portlet.block and @portlet.block.blockable
					@portlet.block.blockable.updated_at = Time.now
					@portlet.block.blockable.save
					if @portlet.block.blockable_type == "Page"

						to_my_log("[Page_"+@portlet.block.blockable.id.to_s+"] "+"Modification de la page "+@portlet.block.blockable.title.to_s+" (modification d'un portlet)")
					end
				end
		
	        	format.html { redirect_to([:admin, @portlet.block.blockable]) }
				format.js { render :template => "portlet/shared/update" }
	        else
	        	format.html { render :action => "portlet/shared/edit" } 
				format.js { render :template => "portlet/shared/edit" }
	        end

		end
	end

	def destroy
		@portlet = Portlet.find(params[:portlet_id])
		@garde_content = GardeContent.find(params[:id])
		@garde_content.destroy
		
		if @portlet.block and @portlet.block.blockable
			@portlet.block.blockable.updated_at = Time.now
			@portlet.block.blockable.save
			if @portlet.block.blockable_type == "Page"

				to_my_log("[Page_"+@portlet.block.blockable.id.to_s+"] "+"Modification de la page "+@portlet.block.blockable.title.to_s+" (suppression d'un portlet)")
			end
		end
		
		respond_to do |format|
			format.html {}
			format.js { render :template => "portlet/shared/destroy" }
		end
	end

 
end
