# -*- encoding : utf-8 -*-
Pharma::Application.routes.draw do


 

	  get "prescriptions/index"

	  get "prescriptions/show"

	  get "prescriptions/delete"

	  get "prescriptions/done"

	  get "prescriptions/undone"

	  get "prescriptions/new"

	  get "prescriptions/create"

	  get "articles/show"

	  get "folders/show"

	  get "home/show"

	  get "menu_items/show"

		resources :download_data_files



		devise_for :admins, :controllers => {:sessions => "admins/sessions", :passwords => "admins/passwords"} 	

		namespace :portlet do
			
			resources :garde_contents do
				collection do
					get :reorder
				end
			end
			resources :break_contents
			resources :download_contents
			resources :dynamic_contents
			resources :gallery_contents
			resources :gallery_images do
				collection do
					get :reorder
				end
			end
			resources :html_contents
			resources :image_contents
			resources :link_contents
			resources :img_link_contents
			resources :text_contents
			resources :map_contents
			resources :title_contents
			resources :table_contents
			resources :block_contents
			resources :table_rows
			resources :table_cols
			resources :portlets do
				collection do
					get :reorder
				end
			end
		end

		namespace :admin do
      get "dashboard/index", :to => "dashboard#index"
      
      
			root :to => "prescriptions#index"
			resources :external_links do
				collection do
					get :cible
				end
			end
			
			resources :folders do
				collection do
					get :cible
				end
			end
			resources :articles
			resources :admins
			resources :menus
			resources :menu_items do
				collection do
					get :cible
				end
			end
			resources :image_files do
				member do
					get :rotate
				end
			end
			resources :file_folders
			resources :data_files
			resources :pages
			resources :menu_urls
			resources :menu_aliases
			resources :blocks
			resources :albums
			resources :promotions
			resources :prescriptions do
				member do
					get :done
					get :undone
					get :file
					get :print
				end
			end

			resources :cibles
			resources :home_pages
			resources :sliders
			resources :slides do 
				collection do 
					get :reorder
				end
			end
			resources :home_blocks


		end 



	 # The priority is based upon order of creation:
	  # first created -> highest priority.

	  # Sample of regular route:
	  #   match 'products/:id' => 'catalog#view'
	  # Keep in mind you can assign values other than :controller and :action

	  # Sample of named route:
	  #   match 'products/:id/purchase' => 'catalog#purchase', :as => :purchase
	  # This route can be invoked with purchase_url(:id => product.id)

	  # Sample resource route (maps HTTP verbs to controller actions automatically):
	  #   resources :products

	  # Sample resource route with options:
	  #   resources :products do
	  #     member do
	  #       get 'short'
	  #       post 'toggle'
	  #     end
	  #
	  #     collection do
	  #       get 'sold'
	  #     end
	  #   end

	  # Sample resource route with sub-resources:
	  #   resources :products do
	  #     resources :comments, :sales
	  #     resource :seller
	  #   end

	  # Sample resource route with more complex sub-resources
	  #   resources :products do
	  #     resources :comments
	  #     resources :sales do
	  #       get 'recent', :on => :collection
	  #     end
	  #   end

	  # Sample resource route within a namespace:
	  #   namespace :admin do
	  #     # Directs /admin/products/* to Admin::ProductsController
	  #     # (app/controllers/admin/products_controller.rb)
	  #     resources :products
	  #   end
		match 'pages/ordonnances/deposer-mon-ordonance-en-ligne.:f' => 'public/prescriptions#create', :as => :create_prescription, :f => "html"
		match 'pages/dossiers/:folder_slug/:slug.:f' => 'public/articles#show', :as => :article, :f => "html"
		match 'pages/dossiers/:slug.:f' => 'public/folders#show', :as => :folder, :f => "html"

		match 'pages/*url.:f' => 'public/menu_items#show', :as => :menu_item, :f => "html"
	  # You can have the root of your site routed with "root"
	  # just remember to delete public/index.html.
	  root :to => "public/home#show"

	  # See how all your routes lay out with "rake routes"

	  # This is a legacy wild controller route that's not recommended for RESTful applications.
	  # Note: This route will make all actions in every controller accessible via GET requests.
	  # match ':controller(/:action(/:id(.:format)))'

	#root :to => "admin/dashboard#index"
end
